<template>
  <div>
    <v-card class="pl-6 pr-6 pb-5 pt-2">
      <v-card-title class="pb-0">
        <h1>
          <b v-if="pedido">{{$t('editarPedido')}}</b>
          <b v-else>{{$t('nuevoPedido')}}</b>
        </h1>
      </v-card-title>
      <v-form v-model="valid" ref="pedidoFrom" class="pb-4 pt-4">
        <v-row>
          <v-col cols="12" lg="4" md="4" sm="12">
            <v-select
              v-model="form.tipo"
              :items="tipos"
              :label="$t('tipo')"
              :disabled="disabled"
            ></v-select>
          </v-col>
          <v-col cols="12" lg="6" md="6" sm="12">
            <h3 v-if="disabled">
              <span class="success--text pt-2">{{ $t('codigoGenerado') }} {{ ' : ' }} {{ codigo }}</span>
            </h3>
          </v-col>
        </v-row>
      </v-form>
      <v-card-actions>
        <v-row>
          <v-btn
            color="accent"
            rounded
            @click="guardarPedido"
            :disabled="disabled"
          >
            {{$t('guardar')}}
          </v-btn>
          <v-btn text color="error" rounded @click="cancelarGuardar">
            {{$t('cancelar')}}
          </v-btn>
          <v-btn text color="secondary" rounded @click="terminar">
            {{$t('terminar')}}
          </v-btn>
          <br/>
        </v-row>
      </v-card-actions>
    </v-card>
  </div>
</template>

<script>
import PedidoServicio from '@/store/services/PedidoServicio'

export default {
  name:'PedidosForm',
  props: {
    pedido: {
      type: Object,
      required: false,
      default: null
    }
  },
  data () {
    return {
      valid: false,
      form: {
        id: null,
        tipo: '',
      },
      rules: {
        isRequired: [value => !!value || this.$t('errorAlCargar')],
      },
      isLoading: false,
      tipos: ['COMPRA', 'PEDIDO'],
      disabled: false,
      codigo: 0
    }
  },
  methods: {
    async guardarPedido() {
      try {
        if (this.$refs.pedidoFrom.validate()) {
          var response = ''
          if (!this.form.id || this.form.id === '') {
            let dataForm = new FormData()
            for (let key in this.form) {
              dataForm.append(key, this.form[key])
            }
            response = await PedidoServicio.create(dataForm)
          } else {
            response = await PedidoServicio.update(this.form.id, this.form)
          }
          this.disabled = true
          this.codigo = response.data.id
          this.$emit('onPedidoGuardado', response.data)
        }
      } catch (e) {console.log(e)
        if (e.response.status > 300) {
          console.log('error pedido')
        }
      }
    },
    cancelarGuardar() {
      this.$refs.pedidoFrom.reset()
      this.disabled = false
      this.$emit('onCancelarGuardar',  false);
    },
    setData() {
      if (this.pedido) {
        this.form.id = this.pedido.id
        this.form.tipo = this.pedido.tipo
      }
    },
    terminar() {
      this.$refs.pedidoFrom.reset()
      this.disabled = false
      this.$emit('onCancelarGuardar',  false);
    }
  },
  computed: {

  },
  watch: {
    pedido() {
      this.setData()
    }
  },
  created() {
    this.setData()
  }
}
</script>

<style>

</style>
